// -*- c++ -*-
//
// $Id: intercomm.cc,v 1.1.1.1.2.1 2001/10/29 04:33:15 bbarrett Exp $
//
// Copyright 1997-2001, University of Notre Dame.
// Authors: Jeffrey M. Squyres, Jeremy G. Siek, Michael P. McNally, and
//          Andrew Lumsdaine
// 
// This file is part of the Notre Dame C++ bindings for MPI.
// 
// You should have received a copy of the License Agreement for the Notre
// Dame C++ bindings for MPI along with the software; see the file
// LICENSE.  If not, contact Office of Research, University of Notre
// Dame, Notre Dame, IN 46556.
// 
// Redistribution and use in source and binary forms, with or without
// modification, are permitted subject to the conditions specified in the
// LICENSE file.
// 
// THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
// DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT,
// INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
// (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
// SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
// HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
// STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
// IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
// POSSIBILITY OF SUCH DAMAGE.
// 
// Additional copyrights may follow.
//

#include "mpi++.h"

MPI::Intercomm MPI::Intercomm::Dup() const
{
  return pmpi_comm.Dup();
}

#if MPI2CPP_VIRTUAL_FUNC_RET
MPI::Intercomm& MPI::Intercomm::Clone() const
{
  PMPI::Comm* pmpi_inter = &pmpi_comm.Clone();
  MPI::Intercomm* mpi_inter = new MPI::Intercomm(*(PMPI::Intercomm*)pmpi_inter);
  return *mpi_inter;
}
#else
MPI::Comm& MPI::Intercomm::Clone() const
{
  // JGS Memory leak, but no other way...
  PMPI::Comm* pmpi_inter = &pmpi_comm.Clone();
  MPI::Intercomm* mpi_inter = new MPI::Intercomm(*(PMPI::Intercomm*)pmpi_inter);
  return *mpi_inter;
}
#endif

int MPI::Intercomm::Get_remote_size() const
{
  return pmpi_comm.Get_remote_size();
}

MPI::Group MPI::Intercomm::Get_remote_group() const
{
  return pmpi_comm.Get_remote_group();
}

MPI::Intracomm MPI::Intercomm::Merge(MPI2CPP_BOOL_T high)
{
  return pmpi_comm.Merge(high);
}
