// -*- c++ -*-
//
// $Id: status.cc,v 1.1.1.1.2.1 2001/10/29 04:33:15 bbarrett Exp $
//
// Copyright 1997-2001, University of Notre Dame.
// Authors: Jeffrey M. Squyres, Jeremy G. Siek, Michael P. McNally, and
//          Andrew Lumsdaine
// 
// This file is part of the Notre Dame C++ bindings for MPI.
// 
// You should have received a copy of the License Agreement for the Notre
// Dame C++ bindings for MPI along with the software; see the file
// LICENSE.  If not, contact Office of Research, University of Notre
// Dame, Notre Dame, IN 46556.
// 
// Redistribution and use in source and binary forms, with or without
// modification, are permitted subject to the conditions specified in the
// LICENSE file.
// 
// THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
// DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT,
// INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
// (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
// SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
// HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
// STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
// IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
// POSSIBILITY OF SUCH DAMAGE.
// 
// Additional copyrights may follow.
//

#include "mpi++.h"

//
// Point-to-Point Communication
//

int
MPI::Status::Get_count(const MPI::Datatype& datatype) const
{
  return pmpi_status.Get_count(datatype);
}

MPI2CPP_BOOL_T
MPI::Status::Is_cancelled() const
{
  return pmpi_status.Is_cancelled();
}

int
MPI::Status::Get_elements(const MPI::Datatype& datatype) const
{
  return pmpi_status.Get_elements(datatype);
}

//
// Status Access
//
int
MPI::Status::Get_source() const
{
  return pmpi_status.Get_source();
}

void
MPI::Status::Set_source(int source)
{
  pmpi_status.Set_source(source);
}
  
int
MPI::Status::Get_tag() const
{
  return pmpi_status.Get_tag();
}
  
void
MPI::Status::Set_tag(int tag)
{
  pmpi_status.Set_tag(tag);
}
  
int
MPI::Status::Get_error() const
{
  return pmpi_status.Get_error();
}

void
MPI::Status::Set_error(int error)
{
  pmpi_status.Set_error(error);
}
