/*
 * Copyright 1998-2001, University of Notre Dame.
 * Authors: Jeffrey M. Squyres, Arun Rodrigues, and Brian Barrett with
 *          Kinis L. Meyer, M. D. McNally, and Andrew Lumsdaine
 * 
 * This file is part of the Notre Dame LAM implementation of MPI.
 * 
 * You should have received a copy of the License Agreement for the Notre
 * Dame LAM implementation of MPI along with the software; see the file
 * LICENSE.  If not, contact Office of Research, University of Notre
 * Dame, Notre Dame, IN 46556.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted subject to the conditions specified in the
 * LICENSE file.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
 * IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 * 
 * Additional copyrights may follow.
 * 
 *	Ohio Trollius
 *	Copyright 1995 The Ohio State University
 *	GDB
 *
 *	$Log: di_wait.int.c,v $
 *	Revision 6.5  2000/02/08 10:29:33  jsquyres
 *	Duh.  Remove the mail headers before trying to compile...
 *	
 *	Revision 6.4  2000/02/08 10:28:37  jsquyres
 *	First take at automake-izing LAM/MPI.  Cross your fingers!
 *	
 *	Revision 6.2  1999/06/12 17:11:35  kmeyer1
 *	added copyright
 *	
 *	Revision 6.1  1996/11/23 18:45:11  nevin
 *	Ohio Release
 *	
 * Revision 6.0  96/02/29  13:32:10  gdburns
 * Ohio Release
 * 
 * Revision 5.2.1.1  96/02/26  20:58:38  gdburns
 * Don't check return value of void kio_intr().
 * 
 * Revision 5.2  94/08/22  13:51:13  gdburns
 * Ohio Release
 * 
 * Revision 5.1.1.1  94/08/18  11:11:41  gdburns
 * overhaul for new kernel
 * 
 * Revision 5.1  94/05/18  10:42:45  gdburns
 * Ohio Release
 * 
 * Revision 2.3  94/04/22  12:28:00  gdburns
 * Ohio Release
 * 
 *	Function:	- waits for network frame message
 *			- registers interrupt function and returns
 *			  to kernel in an 'R' state
 *	Accepts:	- Trollius interrupt number
 *			- socket descriptor
 */

#include <typical.h>

/*
 * external functions
 */
extern int		kio_intr();
extern void		di_forward();

void
di_wait(sockd)

int			sockd;

{
	kio_intr(sockd, di_forward, TRUE);
}
